
import xbmc, xbmcgui, xbmcplugin, xbmcaddon, xbmcvfs
import time, datetime, threading
import json
from .zattooDB import ZattooDB
from .guiactions import *
#from .myplayer import myPlayer
from .tools import *

__addon__       = xbmcaddon.Addon()
__addonId__     = __addon__.getAddonInfo('id')
__addonname__   = __addon__.getAddonInfo('name')
__addondir__    = xbmcvfs.translatePath( __addon__.getAddonInfo('profile') )

_zattooDB_ = ZattooDB()
DEBUG = __addon__.getSetting('debug')
#global player
player = xbmc.Player()
gui = None

accountData=_zattooDB_.zapi.get_accountData()

if __addon__.getSetting('show_favourites')=='true':_listMode_ ='favourites'
else: _listMode_ ='all'

#STREAM_TYPE = __addon__.getSetting('stream_type')
_umlaut_ = {ord('ä'): 'ae', ord('ö'): 'oe', ord('ü'): 'ue', ord('ß'): 'ss'}

def debug(content):
    if DEBUG:log(content, xbmc.LOGDEBUG)

def notice(content):
    log(content, xbmc.LOGINFO)

def log(msg, level=xbmc.LOGINFO):
    addon = xbmcaddon.Addon()
    addonID = addon.getAddonInfo('id')
    xbmc.log('%s: %s' % (addonID, msg), level)

def makeZattooGUI():
    debug("Start GUI")
    xbmcgui.Window(10000).setProperty('zattooGUI', 'True')
    xbmcgui.Dialog().notification('ZattooHiQ', 'GUI started', xbmcgui.NOTIFICATION_INFO, 1500, False)
    xbmc.sleep(2000)
    global gui
    gui = zattooGUI("zattooGUI.xml", __addon__.getAddonInfo('path'))
    gui.doModal()
    #gui.show()
    #while xbmcgui.Window(10000).getProperty('zattooGUI') == 'True': xbmc.sleep(200)
    #del gui
    #xbmcgui.Window(10000).setProperty('zattooGUI', 'False')
    #xbmcgui.Dialog().notification('ZattooHiQ', 'GUI beendet', xbmcgui.NOTIFICATION_WARNING, 2000, False)
    # return

def delZattooGUI():
    global gui, pip
    if 'gui' in globals():
        gui.close()
        del gui
        xbmcgui.Window(10000).setProperty('zattooGUI', 'False')
        xbmcgui.Dialog().notification('ZattooHiQ', 'GUI beendet', xbmcgui.NOTIFICATION_WARNING, 1500, False)
    if 'pip' in globals():
        pip.close()
    
def makeOsdInfo():
    channel_id=_zattooDB_.get_playing()['channel']
    channelInfo = _zattooDB_.get_channelInfo(channel_id)
    program = _zattooDB_.getPrograms({'index':[channel_id]})
    debug(program)
    #program=program[0]
    try: program=program[0]
    except:
        xbmcgui.Dialog().ok('Error',' ','No Info')
        return
    showinfo = _zattooDB_.getShowInfo(program['showID'])
    
    nextprog = _zattooDB_.getPrograms({'index':[channel_id]}, program['end_date']+datetime.timedelta(seconds=60), program['end_date']+datetime.timedelta(seconds=60))
    #debug ('Program: '+str(nextprog))
    if accountData['nonlive']['replay_availability'] == 'available':
        if program['restart'] > datetime.datetime.now() and program['start_date'] < datetime.datetime.now():
            RECALL = True
        else:
            RECALL = False
    else:
        RECALL = False
    try:
        if accountData['nonlive']['recording_number_limit'] > 0:
            if _zattooDB_.getRecord(program['showID']) > datetime.datetime.now():
                RECORD = True
            else:
                RECORD = False
        else:
            RECORD = False
    except:
        RECORD = False

    if RECALL:
        if program['restart']:
            xbmc.executebuiltin( "Skin.SetBool(%s)" %'restart')
        else:
            xbmc.executebuiltin( "Skin.Reset(%s)" %'restart')

    if RECORD:
        xbmc.executebuiltin( "Skin.SetBool(%s)" %'record')
    else:
        xbmc.executebuiltin( "Skin.Reset(%s)" %'record')

    cred = ''
    director = ""
    actor = ""
    genre = ''
    cred = showinfo[0]['cr']
    
    if cred is not None:
        director = ', '.join(cred['director'])
        actor  = ', '.join(cred['actor'])

    genre = ', '.join(showinfo[0]['g'])
    description = program['description']
    if description is None: description = ''
    else: description = '  -  ' + description
    win=xbmcgui.Window(10000)
    win.setProperty('title', program['title'] + description)
    win.setProperty('channelInfo', channelInfo['title'] + ', ' + formatDate(program['start_date'],'%A %H:%M') + '-' + program['end_date'].strftime('%H:%M'))
    win.setProperty('showThumb', showinfo[0]['i_url'])
    win.setProperty('channelLogo', channelInfo['logo'])
    win.setProperty('plot', showinfo[0]['d'])
    win.setProperty('genre', '[COLOR blue]'+ local(135) + ':  ' + '[/COLOR]'+ genre)
    win.setProperty('year', '[COLOR blue]' + local(345) + ':  ' + '[/COLOR]' + str(showinfo[0]['year']))
    win.setProperty('country', '[COLOR blue]' + local(574) + ':  ' + '[/COLOR]' + str(showinfo[0]['country']))
    win.setProperty('director', '[COLOR blue]' + local(20339) + ':  ' + '[/COLOR]' + director)
    win.setProperty('actor', '[COLOR blue]' + local(20337) + ':  ' + '[/COLOR]' + actor)
    win.setProperty('nextprog', '[COLOR blue]' + localString(30010) +'[/COLOR]'+ '[COLOR aquamarine]' + nextprog[0]['title'] + '[/COLOR]' + '  ' + '[COLOR khaki]' + formatDate(nextprog[0]['start_date'],'%A %H:%M')+' - ' +nextprog[0]['end_date'].strftime('%H:%M')+'[/COLOR]')

    played = datetime.datetime.now()-program['start_date']
    total = program['end_date'] - program['start_date']
    #win.setProperty('progress', str((100/total.total_seconds())*played.total_seconds()))
    win.setProperty('progress', str((float(100)/total.seconds)*played.seconds))
    
    win.setProperty('favourite', str(channelInfo['favourite']))
    if channelInfo['favourite']==1: xbmc.executebuiltin( "Skin.SetBool(%s)" %'favourite')
    else: xbmc.executebuiltin( "Skin.Reset(%s)" %'favourite')

def toggle_channel():
    _zattooDB_=ZattooDB()
    toggleChannel=xbmcgui.Window(10000).getProperty('toggleChannel')
    playing=_zattooDB_.get_playing()
    xbmcgui.Window(10000).setProperty('toggleChannel', playing['channel'])
    channelNr = _zattooDB_.get_channelNr(toggleChannel)

    if toggleChannel == '': 
        xbmc.executebuiltin('Action(Back)', True) #go back to channel selector
        xbmcgui.Window(10000).setProperty('toggleChannel', xbmcgui.Window(10000).getProperty('lastChannel'))
    else:
        # GreenAir: new watch_channel parameter and showToggleImg
        watch_channel(toggleChannel, '0', '0', '1')
        gui.showChannelNr(channelNr)
        showToggleImg()
             
def showToggleImg():
    global pip
    pip = zattooPiP("zattooGUI.xml", __addon__.getAddonInfo('path'))
    pip.showToggleImg()
    pip.doModal()
    del pip

def showPreview():
        delZattooGUI()
        from .channelspreview import ChannelsPreview
        preview = ChannelsPreview()
        preview.createPreview(_listMode_ == 'favourites')
        preview.show() #doModal()
        while xbmcgui.Window(10000).getProperty('zattoo_runningView')=="preview": xbmc.sleep(10)
        del preview
        global player
        if player.isPlaying():
            makeZattooGUI()
                
def showEpg():
    delZattooGUI()
    from .epg import EPG
    currentChannel = _zattooDB_.get_playing()['channel']
    channelList = _zattooDB_.getChannelList(_listMode_ == 'favourites')
    #debug(str(channelList))
    try:
        currentNr=channelList[currentChannel]['nr']
    except:
        currentNr=0

    epg = EPG(currentNr)
    epg.loadChannels(_listMode_ == 'favourites')
    epg.show() #doModal()
    while xbmcgui.Window(10000).getProperty('zattoo_runningView')=="epg": xbmc.sleep(200)
    del epg
    global player
    if player.isPlaying():
        makeZattooGUI()

class zattooGUI(xbmcgui.WindowXMLDialog):
    
    def __init__(self, xmlFile, scriptPath):
        #xbmcgui.Window(10000).setProperty('zattooGUI', 'True')
        self.isClosing = False
        self.playing= _zattooDB_.get_playing()
        self.channelID = self.playing['channel']
        channels = _zattooDB_.getChannelList(False)
        debug(self.channelID)
        self.showChannelNr(channels[self.channelID]['nr']+1)
        
    def onAction(self, action):
        key=str(action.getButtonCode())
        actionID = action.getId()
    
        debug('ZATTOOGUI BUTTON '+str(key))
        debug('ZATTOOGUI ACTIONID '+str(actionID))
        # prevent from MouseMove
        if actionID==107: return
        
        #user defined keys
        if key == str(__addon__.getSetting('key_OSD')): self.act_showOSD()
        #elif key==__addon__.getSetting('key_info'): xbmc.executebuiltin("Action(CodecInfo)")
        elif key == str(__addon__.getSetting('key_Preview')): showPreview()
        elif key == str(__addon__.getSetting('key_EPG')): showEPG()
        elif key == str(__addon__.getSetting('key_List')): self.act_showList()
        elif key == str(__addon__.getSetting('key_Teletext')): self.act_teletext()
        elif key == str(__addon__.getSetting('key_nextChan')): self.act_nextChan()
        elif key == str(__addon__.getSetting('key_prevChan')): self.act_prevChan()
        elif key == str(__addon__.getSetting('key_toggleChan')): self.act_toggleChan()
        elif key == str(__addon__.getSetting('key_audio')):  self.act_changeStream()
        elif key == str(__addon__.getSetting('key_recordlist')): self.act_recordList()

        #elif key==__addon__.getSetting('key_pause'): player.pause()
        #elif key==__addon__.getSetting('key_stop'): self.close()
        elif key == str(__addon__.getSetting('key_record')): self.act_record()
        elif key == str(__addon__.getSetting('key_playerosd')): xbmc.executebuiltin("Action(OSD,12005)")
    
        #default actionIDs/keys    
        elif (actionID>57 and actionID<68):self.act_numbers(actionID)
        elif (actionID>141 and actionID<150):
          actionID = actionID - 82
          self.act_numbers(actionID)
        elif actionID  == ACTION_STOP:
          #delZattooGUI()
          player.stop()
        elif actionID in [ACTION_PARENT_DIR, KEY_NAV_BACK, ACTION_PREVIOUS_MENU]: 
            delZattooGUI()
            xbmc.executebuiltin("action(Back)")
        elif actionID in [ACTION_SELECT_ITEM, ACTION_OSD]: self.act_showOSD()
        elif actionID in [ACTION_CHANNEL_UP, ACTION_PAGE_UP, ACTION_SKIPNEXT, ACTION_MOVE_UP]: self.act_prevChan()
        elif actionID in [ACTION_CHANNEL_DOWN, ACTION_PAGE_DOWN, ACTION_SKIPPREW, ACTION_MOVE_DOWN]: self.act_nextChan()
        elif actionID == ACTION_MOVE_LEFT: self.act_toggleChan()
        elif actionID == ACTION_MOVE_RIGHT: self.act_changeStream()
        #else: self.close()
    
    def act_numbers(self,action):
        #print('channel ipnut'+str(action))
        if hasattr(self, 'channelInputTimer'): self.channelInputTimer.cancel()
        self.channelInput+=str(action-58)
        self.channelInputCtrl.setLabel(self.channelInput)
        self.channelInputCtrl.setVisible(True)
        if len(self.channelInput)>2: self.channelInputTimeout()
        else:
            self.channelInputTimer = threading.Timer(1.5, self.channelInputTimeout)
            self.channelInputTimer.start()
         
    def act_prevChan(self):
        self.hideChannelNr()
        nr=self.skip_channel(-1)
        self.showChannelNr(nr+1)
      
    def act_nextChan(self):
        start_time = time.time()
        self.hideChannelNr()
        nr=self.skip_channel(+1)
        self.showChannelNr(nr+1)
      
    def act_showOSD(self):
        if(self.channelInput):
            self.channelInputTimer.cancel()
            self.channelInputTimeout()
        else:
            makeOsdInfo()
            gui = zattooOSD("zattooOSD.xml",__addon__.getAddonInfo('path'))
            gui.doModal()
            
    def act_changeStream(self): 
        streams=player.getAvailableAudioStreams()
        dialog=xbmcgui.Dialog()
        ret = dialog.select('audio streams', streams)
        if ret==-1: return
        player.setAudioStream(ret)
    
    def act_showList(self):
        delZattooGUI()
        xbmc.executebuiltin('ActivateWindow(10025,"plugin://plugin.video.zattoo_hiq/?mode=channellist")')  
              
    def act_showCategory():
        delZattooGUI()
        xbmc.executebuiltin('ActivateWindow(10025,"plugin://plugin.video.zattoo_hiq/?mode=category")')
        
    def act_recordList(self):
        delZattooGUI()
        xbmc.executebuiltin('ActivateWindow(10025,"plugin://plugin.video.zattoo_hiq/?mode=recordings")')

    def act_toggleChan(self):
        #self.hideChannelNr()
        #self.showChannelNr(toggle_channel()+1)
        #self.toggleChannelID=xbmcgui.Window(10000).getProperty('toggleChannel')
        #showToggleImg()
        toggle_channel()
    
    def act_teletext(self):
        from .teletext import Teletext
        tele = Teletext()
        tele.doModal()
        del tele
        
    def channelInputTimeout(self):
        skip=int(self.channelInput)-self.channelNr
        self.showChannelNr(int(self.channelInput))
        self.skip_channel(skip)
        # self.close()
    
    def close(self):
        if hasattr(self, 'hideNrTimer'): self.hideNrTimer.cancel()
        xbmcgui.Window(10000).setProperty('zattooGUI', 'False')
        super(zattooGUI, self).close()
        if not self.isClosing:
            self.isClosing = True
            super(zattooGUI, self).close()

        #xbmc.executebuiltin("action(Back)")
    
    def hideChannelNr(self):
        self.channelInputCtrl.setLabel(' ')
        self.channelInputCtrl.setVisible(False)
        #self.close()
        
    def showChannelNr(self, channelNr):
        if not hasattr(self, 'channelInputCtrl'):
            self.channelInputCtrl = xbmcgui.ControlLabel(1000, 0, 270, 75,'', font='font35_title', alignment=1)
            self.addControl(self.channelInputCtrl)
        self.channelNr=channelNr
        self.channelInput=''
        self.channelInputCtrl.setLabel(str(channelNr))
        self.channelInputCtrl.setVisible(True)
        if hasattr(self, 'hideNrTimer'): self.hideNrTimer.cancel()
        self.hideNrTimer=threading.Timer(3, self.hideChannelNr)
        self.hideNrTimer.start()
           
    def skip_channel(self, skipDir):
        #new ZattooDB instance because this is called from thread-timer on channel-nr input (sql connection doesn't work)
        _zattooDB_=ZattooDB()
    
        channelList = _zattooDB_.getChannelList(_listMode_ == 'favourites')
        currentChannel = _zattooDB_.get_playing()['channel']
        nr=channelList[currentChannel]['nr']
        nr += skipDir
        if nr==len(channelList)-1:
            nr=0
        elif nr<0:
            nr=len(channelList)-2
        channel = channelList['index'][nr]
        program = _zattooDB_.getPrograms({'index':[channel]})[0]
        debug(program)
        if nr<len(channelList) and nr>-1:
            watch_channel(channelList['index'][nr], datetime.datetime.now(), datetime.datetime.now(), program['showID'])
            return nr
        else:
            xbmc.executebuiltin('XBMC.Action(FullScreen)')
            return channelList[currentChannel]['nr']
            
class zattooOSD(xbmcgui.WindowXMLDialog):
    def onInit(self):
        self.getControl(350).setPercent(float(xbmcgui.Window(10000).getProperty('progress')))

    def onAction(self, action):
        action = action.getId()
        #self.close()
        if action in [ACTION_PARENT_DIR, KEY_NAV_BACK, ACTION_PREVIOUS_MENU]:
            if hasattr(self, 'hideNrTimer'): self.hideNrTimer.cancel()
            self.close()
        elif action in [ACTION_STOP, ACTION_BUILT_IN_FUNCTION]:
            if hasattr(self, 'hideNrTimer'): self.hideNrTimer.cancel()
            self.close()
            #print 'Action Stop'
            xbmc.sleep(1000)
            #xbmc.executebuiltin('Action(OSD)') #close hidden gui
            #xbmc.executebuiltin("Action(Back)")
        elif action == ACTION_SKIPPREW:
            xbmc.executebuiltin("Action(Left)")
        elif action == ACTION_SKIPNEXT:
            xbmc.executebuiltin("Action(Right)")

    def onClick(self, controlID):
        channel=_zattooDB_.get_playing()['channel']
        channeltitle=_zattooDB_.get_channeltitle(channel)
        program = _zattooDB_.getPrograms({'index':[channel]}, datetime.datetime.now(), datetime.datetime.now())
        program=program[0]
        self.close() #close OSD

        if controlID==209: #recall
            delZattooGUI() #close hidden gui
            start = int(time.mktime(program['start_date'].timetuple()))
            end = int(time.mktime(program['end_date'].timetuple()))
            showID = program['showID']
            watch_channel(__addonhandle__, channel,start,end, showID, recall='true', add='false')

        elif controlID==210: #record program
            setup_recording(program['showID'])
        elif controlID==211: #teletext
            from .teletext import Teletext
            tele = Teletext()
            tele.doModal()
            del tele
        elif controlID==201: #Back
            self.close()
        elif controlID==202: #Channel Up
            nr=skip_channel(+1)
        elif controlID==203: #Channel Down
            nr=skip_channel(-1)
        elif controlID==205: #stop
            #xbmc.executebuiltin("Action(OSD)")
            xbmc.executebuiltin("Action(Stop)")
            delZattooGUI()
        elif controlID==208: #favourite
            isFavourite=xbmcgui.Window(10000).getProperty('favourite')
            channelList=_zattooDB_.getChannelList()['index']
            update=False

            if isFavourite=="0":
                if xbmcgui.Dialog().yesno(channeltitle, __addon__.getLocalizedString(31908)):
                    channelList.append(channel)
                    update=True
                elif xbmcgui.Dialog().yesno(channeltitle, __addon__.getLocalizedString(31909)):
                    channelList.remove(channel)
                    update=True

            if update:
                channelList=",".join(channelList)

                result=_zattooDB_.zapi.exec_zapiCall('/zapi/channels/favorites/update', {'cids': channelList, 'ctype': 'tv'})
                _zattooDB_.updateChannels(True)
                _zattooDB_.updateProgram()

        elif controlID>300:
            xbmcgui.Window(10000).setProperty('zattoo_runningView',"")
            xbmcgui.Window(10000).setProperty('zattooGUI', 'False')
            xbmc.executebuiltin("Dialog.Close(all,true)") #close hidden GUI
            #xbmc.executebuiltin("Action(OSD)") #close hidden gui

            if controlID==303: xbmc.executebuiltin('ActivateWindow(10025,"plugin://'+__addonId__+'/?mode=channellist")')
            #elif controlID==302: xbmc.executebuiltin('RunPlugin("plugin://'+__addonId__+'/?mode=previewOSD")')
            elif controlID==302: showPreview()
            #elif controlID==301: xbmc.executebuiltin('RunPlugin("plugin://'+__addonId__+'/?mode=epgOSD")')
            elif controlID==301: showEpg()
          
    def onFocus(self, controlID):
        i=10    
        
class zattooPiP(xbmcgui.WindowXMLDialog):
    
    def __init__(self, xmlFile, scriptPath):
        xbmcgui.Window(10000).setProperty('zattooPiP', 'True')
        self.PiP =  __addon__.getSetting('pip')

        if self.PiP == "0":
            self.toggleImgBG =xbmcgui.ControlImage(1280, 574, 260, 148, __addon__.getAddonInfo('path') + '/resources/media/teletextBG.png', aspectRatio=1)
            self.toggleImg =xbmcgui.ControlImage(1280, 576, 256, 144, '', aspectRatio=1)
        else:
            self.toggleImgBG =xbmcgui.ControlImage(1280, 500, 390, 222, __addon__.getAddonInfo('path') + '/resources/media/teletextBG.png', aspectRatio=1)
            self.toggleImg =xbmcgui.ControlImage(1280, 502, 386, 218, '', aspectRatio=1)

        self.addControl(self.toggleImgBG)
        self.addControl(self.toggleImg)
        debug('last cannel :'+str(xbmcgui.Window(10000).getProperty('toggleChannel')))
        self.toggleChannelID=xbmcgui.Window(10000).getProperty('toggleChannel')
        if self.toggleChannelID!="": self.showToggleImg()
        
    def refreshToggleImg(self):
        self.toggleImg.setImage('http://thumb.zattic.com/'+self.toggleChannelID+'/256x144.jpg?r='+str(int(time.time())), False)
        if hasattr(self, 'refreshToggleImgTimer'): self.refreshToggleImgTimer.cancel()
        self.refreshToggleImgTimer=  threading.Timer(5, self.refreshToggleImg)
        self.refreshToggleImgTimer.start()
        
    def showToggleImg(self):

        if self.PiP == "0":
            self.toggleImgBG.setPosition(1022, 574)
            self.toggleImg.setPosition(1024, 576)
        else:
            self.toggleImgBG.setPosition(890, 500)
            self.toggleImg.setPosition(892, 502)
        self.refreshToggleImg()

    def hideToggleImg(self):
        if self.toggleChannelID  != "":  
            self.toggleChannelID = ""
            xbmcgui.Window(10000).setProperty('toggleChannel', '')
            self.toggleImgBG.setPosition(1280, 574)
            self.toggleImg.setPosition(1280, 576)
            if hasattr(self, 'refreshToggleImgTimer'): self.refreshToggleImgTimer.cancel()
            xbmcgui.Dialog().notification('Toggle', 'toggle end', __addon__.getAddonInfo('path') + '/icon.png', 5000, False)    
        
    def close(self):
        if hasattr(self, 'refreshToggleImgTimer'): self.refreshToggleImgTimer.cancel()
        xbmcgui.Window(10000).setProperty('zattooPiP', 'False')
        xbmcgui.Window(10000).setProperty('toggleChannel','')
        super(zattooPiP, self).close()
        
    def onAction(self, action):

        TOGGLE_KEY = __addon__.getSetting('key_toggleChan')
        key=str(action.getButtonCode())
        actionID = action.getId()

        if actionID == ACTION_STOP:
            self.hideToggleImg()
            self.close()
            xbmc.Player().stop()
            gui.close()           
        
        elif actionID in [KEY_NAV_BACK, ACTION_SELECT_ITEM, ACTION_PARENT_DIR, ACTION_MOUSE_LEFT_CLICK]:
            self.hideToggleImg()
            self.close()
        
        elif actionID in [ACTION_MOVE_LEFT, ACTION_GESTURE_SWIPE_LEFT]:
            toggle_channel()
            self.close()
    
        elif key == TOGGLE_KEY:
            toggle_channel()
            self.close()


    
    
