# coding=utf-8
#
#    copyright (C) 2023 Steffen Rolapp (github@rolapp.de)
#
#    This file is part of zattooHiQ
#
#    zattooHiQ is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    zattooHiQ is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with zattooHiQ.  If not, see <http://www.gnu.org/licenses/>.
#

import xbmc, xbmcgui, xbmcaddon, datetime, time, xbmcvfs
import os, urllib.parse
from .zattooDB import ZattooDB
#from .tools import *
import resources.lib.gui as gui
_zattooDB_ = ZattooDB()

__addon__       = xbmcaddon.Addon()
__addondir__    = xbmcvfs.translatePath( __addon__.getAddonInfo('profile') )
__addonId__     = __addon__.getAddonInfo('id')

class myPlayer(xbmc.Player):

    def __init__( self, skip=0, *args):
      
      self.skip=skip
      self.startTime=0
      self.playing=True
      self.playlist = xbmc.PlayList(xbmc.PLAYLIST_VIDEO)
      #debug('Start MyPlayer')
      
    def PlayStream(self, url, listitem):
        self.play(url, listitem)
        #while self.isPlaying():
            #xbmc.sleep(200)  
                
    def is_playing():
        return xbmc.Player().isPlaying()
    
    def onAVStarted(self):
        #debug('Start Playback')
        #from .zattooDB import ZattooDB
        #_zattooDB_ = ZattooDB()
        global live
        live = 'false'
        streams = xbmc.getInfoLabel('Player.FilenameAndPath')
        vinfo = xbmc.Player().getVideoInfoTag()
        #debug(streams)
        showID = vinfo.getUniqueID('imdb')
        channel = vinfo.getUniqueID('tvdb')
        _zattooDB_.set_playing(channel, showID, streams, 0)
        playing = _zattooDB_.get_playing()
        xbmcgui.Window(10000).setProperty('lastChannel', channel)
        
        
        # load Keymap for liveTV
        if streams.find('-live')>-1 :
            live = 'true'
            
            self.loadKeymap()
            #xbmcgui.Window(10000).setProperty('zattooGUI', 'True')
            if xbmcgui.Window(10000).getProperty('zattooGUI') == 'False':
                xbmc.sleep(200)
                gui.makeZattooGUI()
        else: 
            self.unloadKeymap()
            
    def onPlayBackStopped(self):
      if live == 'true':
        gui.delZattooGUI()
      self.unloadKeymap()
      self.playing=False
      self.playlist.clear()

    def onPlayBackEnded(self):
      if live == 'true':
        gui.delZattooGUI()
      self.unloadKeymap()
      self.playing=False
      playing = _zattooDB_.get_playing()
      if playing['channel'] != '': 
          ret = xbmcgui.Window(12005).getProperty('after_recall')
          #GreenAir: switch to live
          if ret == "1":
            playing = _zattooDB_.get_playing()
            xbmc.executebuiltin('RunPlugin("plugin://'+__addonId__+'/?mode=watch_c&id='+playing['channel'] +'")')
          #GreenAir: continue with next recall
          elif ret == "2":
            playing = _zattooDB_.get_playing()
            program = _zattooDB_.get_showID(playing['showID'])[0]
            nextprog = _zattooDB_.getPrograms({'index':[program['channel']]}, True, program['end_date']+datetime.timedelta(seconds=20), program['end_date']+datetime.timedelta(seconds=50))[0]
    
            xbmc.executebuiltin('RunPlugin("plugin://'+__addonId__+'/?mode=watch_c&id='+nextprog['channel'] + '&showID=' + nextprog['showID'] +'&restart=true")')
    
            notice ('continueRecall program:'+str(program))
            notice ('continueRecall nextprog:'+str(nextprog))

            
    def loadKeymap(self):

      source = __addondir__ + '/zattooKeymap.xml'
      dest = xbmcvfs.translatePath('special://profile/keymaps/zattooKeymap.xml')
      if os.path.isfile(dest): return
      with open(source, 'r') as file: content = file.read()
      with open(dest, 'w') as file: file.write(content)
      xbmc.sleep(50)
      xbmc.executebuiltin('Action(reloadkeymaps)')

    def unloadKeymap(self):

      path=xbmcvfs.translatePath('special://profile/keymaps/zattooKeymap.xml')
      if os.path.isfile(path):
        try:
          os.remove(path)
          xbmc.sleep(200)
          xbmc.executebuiltin('Action(reloadkeymaps)')
        except:pass

#monitor = xbmc.Monitor()
#player = myPlayer() 
#debug('Start MyPlayer')
#while not monitor.abortRequested(): 
#    if monitor.waitForAbort(2):break
